## ros-iron-rosbag2-cpp 0.22.3

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.5)
project(rosbag2_cpp)

add_definitions(-D_SRC_REINDEX_DIR_PATH="${CMAKE_CURRENT_SOURCE_DIR}/test/rosbag2_cpp/reindex_test_bags")

# Default to C99
if(NOT CMAKE_C_STANDARD)
  set(CMAKE_C_STANDARD 99)
endif()

# Default to C++17
if(NOT CMAKE_CXX_STANDARD)
  set(CMAKE_CXX_STANDARD 17)
  set(CMAKE_CXX_STANDARD_REQUIRED ON)
endif()

if(CMAKE_COMPILER_IS_GNUCXX OR CMAKE_CXX_COMPILER_ID MATCHES "Clang")
  add_compile_options(-Wall -Wextra -Wpedantic)
endif()
if(CMAKE_CXX_COMPILER_ID MATCHES "Clang")
  add_compile_options(-Wthread-safety)
endif()

# Windows supplies macros for min and max by default. We should only use min and max from stl
if(WIN32)
  add_definitions(-DNOMINMAX)
endif()

option(DISABLE_SANITIZERS "disables the use of gcc sanitizers" ON)
if(NOT DISABLE_SANITIZERS AND CMAKE_COMPILER_IS_GNUCXX)
  include(CheckCXXSourceRuns)
  set(OLD_CMAKE_REQUIRED_FLAGS ${CMAKE_REQUIRED_FLAGS})
  set(CMAKE_REQUIRED_FLAGS "${OLD_CMAKE_REQUIRED_FLAGS} -fsanitize=leak")
  check_cxx_source_runs("int main() {}" HAVE_SANITIZERS)
  set(CMAKE_REQUIRED_FLAGS ${OLD_CMAKE_REQUIRED_FLAGS})
  if(NOT HAVE_SANITIZERS)
    set(DISABLE_SANITIZERS ON)
    message(WARNING "Sanitizers aren't supported by the compiler or environment - disabling")
  endif()
endif()

find_package(ament_cmake REQUIRED)
find_package(ament_index_cpp REQUIRED)
find_package(pluginlib REQUIRED)
find_package(rclcpp REQUIRED)
find_package(rcpputils REQUIRED)
find_package(rcutils REQUIRED)
find_package(rmw REQUIRED)
find_package(rmw_implementation REQUIRED)
find_package(rosbag2_storage REQUIRED)
find_package(rosidl_runtime_c REQUIRED)
find_package(rosidl_runtime_cpp REQUIRED)
find_package(rosidl_typesupport_cpp REQUIRED)
find_package(rosidl_typesupport_introspection_cpp REQUIRED)

add_library(${PROJECT_NAME} SHARED
  src/rosbag2_cpp/cache/cache_consumer.cpp
  src/rosbag2_cpp/cache/message_cache_buffer.cpp
  src/rosbag2_cpp/cache/message_cache_circular_buffer.cpp
  src/rosbag2_cpp/cache/message_cache.cpp
  src/rosbag2_cpp/cache/circular_message_cache.cpp
  src/rosbag2_cpp/clocks/time_controller_clock.cpp
  src/rosbag2_cpp/converter.cpp
  src/rosbag2_cpp/info.cpp
  src/rosbag2_cpp/message_definitions/local_message_definition_source.cpp
  src/rosbag2_cpp/reader.cpp
  src/rosbag2_cpp/readers/sequential_reader.cpp
  src/rosbag2_cpp/rmw_implemented_serialization_format_converter.cpp
  src/rosbag2_cpp/serialization_format_converter_factory.cpp
  src/rosbag2_cpp/types/introspection_message.cpp
  src/rosbag2_cpp/typesupport_helpers.cpp
  src/rosbag2_cpp/types/introspection_message.cpp
  src/rosbag2_cpp/writer.cpp
  src/rosbag2_cpp/writers/sequential_writer.cpp
  src/rosbag2_cpp/reindexer.cpp)

target_link_libraries(${PROJECT_NAME}
  PUBLIC
  ament_index_cpp::ament_index_cpp
  pluginlib::pluginlib
  rclcpp::rclcpp
  rcpputils::rcpputils
  rcutils::rcutils
  rmw::rmw
  rmw_implementation::rmw_implementation
  rosbag2_storage::rosbag2_storage
  rosidl_runtime_c::rosidl_runtime_c
  rosidl_runtime_cpp::rosidl_runtime_cpp
  rosidl_typesupport_cpp::rosidl_typesupport_cpp
  rosidl_typesupport_introspection_cpp::rosidl_typesupport_introspection_cpp
)

target_include_directories(${PROJECT_NAME}
  PUBLIC
  $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/include>
  $<INSTALL_INTERFACE:include/${PROJECT_NAME}>
)

# Causes the visibility macros to use dllexport rather than dllimport,
# which is appropriate when building the dll but not consuming it.
target_compile_definitions(${PROJECT_NAME} PRIVATE "ROSBAG2_CPP_BUILDING_DLL")

install(
  DIRECTORY include/
  DESTINATION include/${PROJECT_NAME})

install(
  TARGETS ${PROJECT_NAME}
  EXPORT export_${PROJECT_NAME}
  ARCHIVE DESTINATION lib
  LIBRARY DESTINATION lib
  RUNTIME DESTINATION bin)

# Export old-style CMake variables
ament_export_include_directories("include/${PROJECT_NAME}")
ament_export_libraries(${PROJECT_NAME})

# Export modern CMake targets
ament_export_targets(export_${PROJECT_NAME})

ament_export_dependencies(
  pluginlib
  rclcpp
  rmw
  rmw_implementation
  rosbag2_storage
  rosidl_runtime_c
  rosidl_runtime_cpp
  rosidl_typesupport_cpp
  rosidl_typesupport_introspection_cpp
)

if(BUILD_TESTING)
  find_package(ament_cmake_gmock REQUIRED)
  find_package(ament_lint_auto REQUIRED)
  find_package(test_msgs REQUIRED)
  find_package(rosbag2_test_msgdefs REQUIRED)
  ament_lint_auto_find_test_dependencies()

  add_library(
    converter_test_plugins
    SHARED
    test/rosbag2_cpp/serializer_test_plugin.cpp
    test/rosbag2_cpp/converter_test_plugin.cpp)
  target_link_libraries(converter_test_plugins
    ${PROJECT_NAME}
    rosbag2_storage::rosbag2_storage
  )
  install(
    TARGETS converter_test_plugins
    ARCHIVE DESTINATION lib
    LIBRARY DESTINATION lib
    RUNTIME DESTINATION bin)
  pluginlib_export_plugin_description_file(rosbag2_cpp test/rosbag2_cpp/converter_test_plugin.xml)

  ament_add_gmock(test_converter_factory
    test/rosbag2_cpp/test_converter_factory.cpp)
  if(TARGET test_converter_factory)
    target_link_libraries(test_converter_factory ${PROJECT_NAME})
  endif()

  ament_add_gmock(test_typesupport_helpers
    test/rosbag2_cpp/test_typesupport_helpers.cpp
    WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR})
  if(TARGET test_typesupport_helpers)
    target_link_libraries(test_typesupport_helpers ${PROJECT_NAME})
  endif()

  ament_add_gmock(test_info
    test/rosbag2_cpp/test_info.cpp
    WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR})
  if(TARGET test_info)
    target_link_libraries(test_info ${PROJECT_NAME})
    ament_target_dependencies(test_info rosbag2_test_common test_msgs)
  endif()

  ament_add_gmock(test_sequential_reader
    test/rosbag2_cpp/test_sequential_reader.cpp test/rosbag2_cpp/fake_data.cpp)
  if(TARGET test_sequential_reader)
    ament_target_dependencies(test_sequential_reader rosbag2_storage rosbag2_test_common test_msgs)
    target_link_libraries(test_sequential_reader ${PROJECT_NAME})
  endif()

  ament_add_gmock(test_storage_without_metadata_file
    test/rosbag2_cpp/test_storage_without_metadata_file.cpp)
  if(TARGET test_storage_without_metadata_file)
    ament_target_dependencies(test_storage_without_metadata_file rosbag2_storage)
    target_link_libraries(test_storage_without_metadata_file ${PROJECT_NAME})
  endif()

  ament_add_gmock(test_local_message_definition_source
    test/rosbag2_cpp/test_local_message_definition_source.cpp)
  if(TARGET test_local_message_definition_source)
    target_link_libraries(test_local_message_definition_source ${PROJECT_NAME})
  endif()

  ament_add_gmock(test_message_cache
    test/rosbag2_cpp/test_message_cache.cpp)
  if(TARGET test_message_cache)
    target_link_libraries(test_message_cache ${PROJECT_NAME})
  endif()

  ament_add_gmock(test_circular_message_cache
    test/rosbag2_cpp/test_circular_message_cache.cpp)
  if(TARGET test_circular_message_cache)
    target_link_libraries(test_circular_message_cache ${PROJECT_NAME})
  endif()


  # If compiling with gcc, run this test with sanitizers enabled
  ament_add_gmock(test_ros2_message
    test/rosbag2_cpp/types/test_ros2_message.cpp
    src/rosbag2_cpp/typesupport_helpers.cpp
    src/rosbag2_cpp/types/introspection_message.cpp)
  if(TARGET test_ros2_message)
    target_compile_definitions(test_ros2_message PRIVATE "ROSBAG2_CPP_BUILDING_DLL")
    if(NOT DISABLE_SANITIZERS)
      target_compile_options(test_ros2_message PUBLIC $<$<CXX_COMPILER_ID:GNU>:-fsanitize=leak>)
      target_link_libraries(test_ros2_message $<$<CXX_COMPILER_ID:GNU>:-fsanitize=leak>)
    endif()
    target_include_directories(test_ros2_message
      PUBLIC
      $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/include>)
    target_link_libraries(test_ros2_message
      ament_index_cpp::ament_index_cpp
      rcpputils::rcpputils
      rosbag2_storage::rosbag2_storage
      rosidl_runtime_cpp::rosidl_runtime_cpp
      rosidl_typesupport_introspection_cpp::rosidl_typesupport_introspection_cpp
      rosidl_typesupport_cpp::rosidl_typesupport_cpp
      ${test_msgs_TARGETS}
    )
  endif()

  ament_add_gmock(test_sequential_writer
    test/rosbag2_cpp/test_sequential_writer.cpp test/rosbag2_cpp/fake_data.cpp)
  if(TARGET test_sequential_writer)
    target_link_libraries(test_sequential_writer
      ${PROJECT_NAME}
      rosbag2_storage::rosbag2_storage
      rosbag2_test_common::rosbag2_test_common
      ${test_msgs_TARGETS}
    )
  endif()

  ament_add_gmock(test_multifile_reader
    test/rosbag2_cpp/test_multifile_reader.cpp)
  if(TARGET test_multifile_reader)
    target_link_libraries(test_multifile_reader
      ${PROJECT_NAME}
      rosbag2_storage::rosbag2_storage
    )
  endif()

  ament_add_gmock(test_time_controller_clock
    test/rosbag2_cpp/test_time_controller_clock.cpp)
  if(TARGET test_time_controller_clock)
    target_link_libraries(test_time_controller_clock ${PROJECT_NAME})
  endif()
endif()

ament_package()

=== debian/changelog ===
ros-iron-rosbag2-cpp (0.22.3-1jammy) jammy; urgency=high



 -- Michael Orlov <michael.orlov@apex.ai>  Thu, 07 Sep 2023 16:00:00 -0000

ros-iron-rosbag2-cpp (0.22.2-1jammy) jammy; urgency=high

  * Rewrite TimeControllerClockTest.unpaused_sleep_returns_true to be correct (#1389 <https://github.com/ros2/rosbag2/issues/1389>)
  * Don't crash when type definition cannot be found (#1352 <https://github.com/ros2/rosbag2/issues/1352>)
  * Contributors: Emerson Knapp

 -- Michael Orlov <michael.orlov@apex.ai>  Thu, 13 Jul 2023 16:00:00 -0000

ros-iron-rosbag2-cpp (0.22.1-1jammy) jammy; urgency=high

  * Add recorder stop() API (#1300 <https://github.com/ros2/rosbag2/issues/1300>) (#1334 <https://github.com/ros2/rosbag2/issues/1334>)
  * Contributors: mergify[bot]

 -- Michael Orlov <michael.orlov@apex.ai>  Wed, 17 May 2023 16:00:00 -0000

ros-iron-rosbag2-cpp (0.22.0-1jammy) jammy; urgency=high

  * Add type_hash in MessageDefinition struct (#1296 <https://github.com/ros2/rosbag2/issues/1296>)
  * Add message definition read API (#1292 <https://github.com/ros2/rosbag2/issues/1292>)
  * rosbag2_storage: add type description hash to topic metadata (#1272 <https://github.com/ros2/rosbag2/issues/1272>)
  * Fix for flaky TimeControllerClockTest::unpaused_sleep_returns_true test (#1290 <https://github.com/ros2/rosbag2/issues/1290>)
  * Contributors: Michael Orlov, james-rms

 -- Michael Orlov <michael.orlov@apex.ai>  Mon, 17 Apr 2023 16:00:00 -0000

ros-iron-rosbag2-cpp (0.21.0-1jammy) jammy; urgency=high

  * rosbag2_cpp: move local message definition source out of MCAP plugin (#1265 <https://github.com/ros2/rosbag2/issues/1265>)
  * Update rosbag2 to C++17. (#1238 <https://github.com/ros2/rosbag2/issues/1238>)
  * Use target_link_libraries instead of ament_target_dependencies (#1202 <https://github.com/ros2/rosbag2/issues/1202>)
  * Fix rwm->rmw spelling (#1249 <https://github.com/ros2/rosbag2/issues/1249>)
  * Contributors: Chris Lalancette, Daisuke Nishimatsu, Emerson Knapp, Michael Orlov, james-rms

 -- Michael Orlov <michael.orlov@apex.ai>  Tue, 11 Apr 2023 16:00:00 -0000

ros-iron-rosbag2-cpp (0.20.0-1jammy) jammy; urgency=high



 -- Michael Orlov <michael.orlov@apex.ai>  Mon, 13 Feb 2023 16:00:00 -0000

ros-iron-rosbag2-cpp (0.19.0-1jammy) jammy; urgency=high

  * Expose more Writer methods in python interface (#1220 <https://github.com/ros2/rosbag2/issues/1220>)
  * rosbag2_storage: set MCAP as default plugin (#1160 <https://github.com/ros2/rosbag2/issues/1160>)
  * Parametrize all rosbag2_tests for both supported storage plugins (#1221 <https://github.com/ros2/rosbag2/issues/1221>)
  * rosbag2_cpp: test more than one storage plugin (#1196 <https://github.com/ros2/rosbag2/issues/1196>)
  * Replace language for "db3"/"db"/"database" (#1194 <https://github.com/ros2/rosbag2/issues/1194>)
  * set_read_order: return success (#1177 <https://github.com/ros2/rosbag2/issues/1177>)
  * Remove explicit sqlite3 from code (#1166 <https://github.com/ros2/rosbag2/issues/1166>)
  * Add update_metadata(BagMetadata) API for storage plugin interface (#1149 <https://github.com/ros2/rosbag2/issues/1149>)
  * Reader and writer can use default storage by not specifying (#1167 <https://github.com/ros2/rosbag2/issues/1167>)
  * Contributors: Emerson Knapp, Michael Orlov, james-rms

 -- Michael Orlov <michael.orlov@apex.ai>  Thu, 12 Jan 2023 16:00:00 -0000

ros-iron-rosbag2-cpp (0.18.0-1jammy) jammy; urgency=high

  * rosbag2_storage: expose default storage ID as method (#1146 <https://github.com/ros2/rosbag2/issues/1146>)
  * Don't reopen file for every seek if we don't have to. Search directionally for the correct file (#1117 <https://github.com/ros2/rosbag2/issues/1117>)
  * Add SplitBagfile recording service. (#1115 <https://github.com/ros2/rosbag2/issues/1115>)
  * Reverse read order API and sqlite storage implementation (#1083 <https://github.com/ros2/rosbag2/issues/1083>)
  * Replace std::filesystem::path(..) with rcpputils::fs::path(..) (#1104 <https://github.com/ros2/rosbag2/issues/1104>)
  * Fix issue where sequentialwriter only sets metadata duration to the duration of the final file (#1098 <https://github.com/ros2/rosbag2/issues/1098>)
  * Delete obsolete compression_options.cpp from rosbag2_cpp (#1078 <https://github.com/ros2/rosbag2/issues/1078>)
  * Readers/info can accept a single bag storage file, and detect its storage id automatically (#1072 <https://github.com/ros2/rosbag2/issues/1072>)
  * Remove deprecated rosbag2_cpp/storage_options.hpp, for post-Humble releases (#1064 <https://github.com/ros2/rosbag2/issues/1064>)
  * Contributors: Emerson Knapp, Michael Orlov, james-rms, rshanor

 -- Michael Orlov <michael.orlov@apex.ai>  Mon, 14 Nov 2022 16:00:00 -0000

ros-iron-rosbag2-cpp (0.17.0-1jammy) jammy; urgency=high

  * Speed optimization: Preparing copyless publish/subscribing by using const message for writing (#1010 <https://github.com/ros2/rosbag2/issues/1010>)
  * Add the ability to record any key/value pair in 'custom' field in metadata.yaml (#1038 <https://github.com/ros2/rosbag2/issues/1038>)
  * Notification of significant events during bag recording and playback (#908 <https://github.com/ros2/rosbag2/issues/908>)
  * Bugfix for "Playing the bags recorded with split by duration/size is playing only the last recorded .db3." (#1022 <https://github.com/ros2/rosbag2/issues/1022>)
  * Improve test_time_controller test (#1012 <https://github.com/ros2/rosbag2/issues/1012>)
  * Contributors: DensoADAS, Geoffrey Biggs, Hunter L. Allen, Jorge Perez, Kaju-Bubanja, Michael Orlov, Joshua Hampp, Tony Peng

 -- Michael Orlov <michael.orlov@apex.ai>  Fri, 29 Jul 2022 16:00:00 -0000

ros-iron-rosbag2-cpp (0.16.0-1jammy) jammy; urgency=high



 -- Michael Orlov <michael.orlov@apex.ai>  Tue, 10 May 2022 16:00:00 -0000

ros-iron-rosbag2-cpp (0.15.1-1jammy) jammy; urgency=high



=== debian/control ===
Source: ros-iron-rosbag2-cpp
Section: misc
Priority: optional
Maintainer: Michael Orlov <michael.orlov@apex.ai>
Build-Depends: debhelper (>= 9.0.0), ros-iron-ament-cmake, ros-iron-ament-cmake-gmock <!nocheck>, ros-iron-ament-index-cpp, ros-iron-ament-lint-auto <!nocheck>, ros-iron-ament-lint-common <!nocheck>, ros-iron-pluginlib, ros-iron-rclcpp, ros-iron-rcpputils, ros-iron-rcutils, ros-iron-rmw, ros-iron-rmw-implementation, ros-iron-rosbag2-storage, ros-iron-rosbag2-storage-default-plugins <!nocheck>, ros-iron-rosbag2-test-common <!nocheck>, ros-iron-rosbag2-test-msgdefs <!nocheck>, ros-iron-rosidl-runtime-c, ros-iron-rosidl-runtime-cpp, ros-iron-rosidl-typesupport-cpp, ros-iron-rosidl-typesupport-introspection-cpp, ros-iron-shared-queues-vendor, ros-iron-test-msgs <!nocheck>, ros-iron-ros-workspace
Homepage: 
Standards-Version: 3.9.2

Package: ros-iron-rosbag2-cpp
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, ros-iron-ament-index-cpp, ros-iron-pluginlib, ros-iron-rclcpp, ros-iron-rcpputils, ros-iron-rcutils, ros-iron-rmw, ros-iron-rmw-implementation, ros-iron-rosbag2-storage, ros-iron-rosidl-runtime-c, ros-iron-rosidl-runtime-cpp, ros-iron-rosidl-typesupport-cpp, ros-iron-rosidl-typesupport-introspection-cpp, ros-iron-shared-queues-vendor, ros-iron-ros-workspace
Description: C++ ROSBag2 client library

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1
# TODO: remove the LDFLAGS override.  It's here to avoid esoteric problems
# of this sort:
#  https://code.ros.org/trac/ros/ticket/2977
#  https://code.ros.org/trac/ros/ticket/3842
export LDFLAGS=
export PKG_CONFIG_PATH=/opt/ros/iron/lib/pkgconfig
# Explicitly enable -DNDEBUG, see:
# 	https://github.com/ros-infrastructure/bloom/issues/327
export DEB_CXXFLAGS_MAINT_APPEND=-DNDEBUG
ifneq ($(filter nocheck,$(DEB_BUILD_OPTIONS)),)
	BUILD_TESTING_ARG=-DBUILD_TESTING=OFF
endif

DEB_HOST_GNU_TYPE ?= $(shell dpkg-architecture -qDEB_HOST_GNU_TYPE)

%:
	dh $@ -v --buildsystem=cmake --builddirectory=.obj-$(DEB_HOST_GNU_TYPE)

override_dh_auto_configure:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/iron/setup.sh" ]; then . "/opt/ros/iron/setup.sh"; fi && \
	dh_auto_configure -- \
		-DCMAKE_INSTALL_PREFIX="/opt/ros/iron" \
		-DAMENT_PREFIX_PATH="/opt/ros/iron" \
		-DCMAKE_PREFIX_PATH="/opt/ros/iron" \
		$(BUILD_TESTING_ARG)

override_dh_auto_build:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/iron/setup.sh" ]; then . "/opt/ros/iron/setup.sh"; fi && \
	dh_auto_build

override_dh_auto_test:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	echo -- Running tests. Even if one of them fails the build is not canceled.
	if [ -f "/opt/ros/iron/setup.sh" ]; then . "/opt/ros/iron/setup.sh"; fi && \
	dh_auto_test || true

override_dh_shlibdeps:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/iron/setup.sh" ]; then . "/opt/ros/iron/setup.sh"; fi && \
	dh_shlibdeps -l$(CURDIR)/debian/ros-iron-rosbag2-cpp//opt/ros/iron/lib/

override_dh_auto_install:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/iron/setup.sh" ]; then . "/opt/ros/iron/setup.sh"; fi && \
	dh_auto_install
